#if !defined(__sys_fdb_h)
#define __sys_fdb_h

#if !defined(_NO_IDENTS) && defined(_HEAD_IDENTS)
# pragma ident "@(#)head:sys/fdb.h	1.5 90/09/07 {Apple version 3.0 90/11/29 11:37:56}"
#endif

/*
 * Copyright 1987, 1988, 1989 Apple Computer, Inc.
 * All Rights Reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF APPLE COMPUTER, INC.
 * The copyright notice above does not evidence any actual or
 * intended publication of such source code.
 */

/*
 * Copyright 1986 Unisoft Corporation of Berkeley CA
 */

#define FDB_LISTEN	0x01		/* a listen completed */
#define FDB_TALK	0x02		/* a talk completed */
#define	FDB_EXISTS	0x04		/* a 'exists' completed */
#define	FDB_FLUSH	0x08		/* a flush completed */
#define	FDB_RESET	0x10		/* a reset completed */
#define	FDB_INT		0x20		/* an interrupt occured */
#define	FDB_POLL	0x40		/* a poll succeeded */
#define	FDB_UNINT	0x80		/* an int poll failed */

#define	F_RESET		0x00
#define	F_FLUSH		0x01
#define	F_LISTEN	0x08
#define	F_TALK		0x0c

#define FDB_KEYBOARD	2
#define FDB_MOUSE	3

/* ADB I/O Processor Interface */

/* IOP and channel values: */
#define	ADB_IOP		1	/* ADB done by the SWIM IOP */
#define	ADB_CHAN	3	/* the ADB driver */

struct adbmsg {
    unsigned char flags;	/* ADB flags */
    unsigned char count;	/* count of ADB data bytes */
    unsigned char cmd;		/* ADB command */
    unsigned char data[8];	/* ADB data */
    unsigned char unused[21];
};

/* Flag bits: */

#define	ADB_EXPLICIT	0x80	/* explicit command (else implicit if 0) */
#define	ADB_AUTOPOLL	0x40	/* auto/SRQ polling enabled */
#define	ADB_SRQ		0x04	/* SRQ detected */
#define	ADB_TIMEOUT	0x02	/* timeout (else valid data if 0) */

#endif /* __sys_fdb_h */
