#if !defined(__sys_fdioctl_h)
#define __sys_fdioctl_h

#if !defined(_NO_IDENTS) && defined(_HEAD_IDENTS)
# pragma ident "@(#)head:sys/fdioctl.h	1.10 91/07/10 {Apple version 3.0 90/11/29 11:37:56}"
#endif

/*
 * Copyright 1987, 1988, 1989 Apple Computer, Inc.
 * All Rights Reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF APPLE COMPUTER, INC.
 * The copyright notice above does not evidence any actual or
 * intended publication of such source code.
 */

/* Header file for floppy disk IOCTL functions. */

/* Get and set the metering counters: */

struct fd_meter {
    int rev;				/* revision x.mn as 100x + 10m + n */
    int reqcount;			/* total I/O read/write requests */
    int offcyl;				/* not on cyl when r/w req starts */
    int ioerrors;			/* count of blocks read errors */
    int addrerrors;			/* count of read-address errors */
    int opens;				/* total successful opens */
					/* format found each successful open */
    int fmt_gcr400;			/*  400K GCR */
    int fmt_gcr800;			/*  800K GCR */
    int fmt_mfm720;			/*  720K MFM */
    int fmt_mfm1440;			/* 1440K MFM */
    int fmt_none;			/* no disk but O_NDELAY asked */
    int fmt_illegal;			/* illegal */
    int fmt_unformatted;		/* unformatted */

    /* Blkcount is a set of buckets for 1,2,4,8,...4096 blocks per request */
    int blkcount[13];			/* no. blocks per request */
};

/* Get and set the tuning values. Do this with care! */

struct fd_tune {
    int gf_tries;			/* getformat: max address tries */
    int sectretry;			/* max read retries per sector */
    int addrretry;			/* read-address retries till reseek */
    int maxrecal;			/* max recalibrates per track */
    int maxreseek;			/* max reseek tries till recal */
    int maxrevs;			/* max revolutions to do a track */
};

#ifndef _IOCTL_
#if defined(__MPW_C__)
# include "/:usr:include:sys:ioctl.h"
#else
# include <sys/ioctl.h>
#endif
#endif

#ifndef AL_EJECT
#define AL_EJECT	_IO('L', 0x22)	/* eject the sony diskette */
#endif

#define	FD_GETMETER	_IOR('L',1,struct fd_meter)	/* get meter */
#define	FD_SETMETER	_IOW('L',2,struct fd_meter)	/* set meter */
#define	FD_GETTUNE	_IOR('L',3,struct fd_tune)	/* get tuning */
#define	FD_SETTUNE	_IOW('L',4,struct fd_tune)	/* set tuning */
#define	FD_GETSTAT	_IO('L',5)			/* get status */
#define FD_FMTONLY	_IOW('L',6,struct diskformat)	/* format disk - no verify */
#define FD_VFYONLY	_IOW('L',7,struct diskformat)	/* verify disk - no format */

/* Status bits returned by FD_GETSTATUS: */

#define	STAT_FDHD	0x0001		/* drive is an FDHD */
#define	STAT_2SIDED	0x0002		/* drive is doublesided */
#define	STAT_NODRIVE	0x0004		/* no drive present */
#define	STAT_NODISK	0x0008		/* no diskette in drive */
#define	STAT_WRTENAB	0x0010		/* diskette is write-enabled */
#define	STAT_1MBMEDIA	0x0020		/* diskette is 1MB (not HD) media */
#define	STAT_HAVESWIM	0x0040		/* interface is SWIM chip, now IWM */

#endif /* __sys_fdioctl_h */
