#if !defined(__mac_serial_h)
#define __mac_serial_h

#if !defined(_NO_IDENTS) && defined(_HEAD_IDENTS)
# pragma ident "@(#)head:mac/serial.h        1.5 91/07/10 "
#endif

/*
 * Copyright 1985-91 Apple Computer, Inc.
 * All Rights Reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF APPLE COMPUTER, INC.
 * The copyright notice above does not evidence any actual or
 * intended publication of such source code.
 */

/************************************************************

Created: Thursday, September 8, 1988 at 9:31 PM
    serial.h
    C Interface to the Macintosh Libraries

************************************************************/

#if !defined(__mac_types_h)
# if defined(__MPW_C__)
#   include "/:usr:include:mac:types.h"
# else
#   include <mac/types.h>
# endif
#endif

#define baud300 380
#define baud600 189
#define baud1200 94
#define baud1800 62
#define baud2400 46
#define baud3600 30
#define baud4800 22
#define baud7200 14
#define baud9600 10
#define baud19200 4
#define baud57600 0
#define stop10 16384
#define stop15 -32768
#define stop20 -16384
#define noParity 0
#define oddParity 4096
#define evenParity 12288
#define data5 0
#define data6 2048
#define data7 1024
#define data8 3072
#define ctsEvent 32
#define breakEvent 128
#define xOffWasSent 128
#define dtrNegated 64
#define ainRefNum -6        /*serial port A input*/
#define aoutRefNum -7       /*serial port A output*/
#define binRefNum -8        /*serial port B input*/
#define boutRefNum -9       /*serial port B output*/

enum {sPortA,sPortB};
typedef unsigned char SPortSel;

struct SerShk {
    char fXOn;              /*XOn flow control enabled flag*/
    char fCTS;              /*CTS flow control enabled flag*/
    unsigned char xOn;      /*XOn character*/
    unsigned char xOff;     /*XOff character*/
    char errs;              /*errors mask bits*/
    char evts;              /*event enable mask bits*/
    char fInX;              /*Input flow control enabled flag*/
    char fDTR;              /*DTR input flow control flag*/
};

typedef struct SerShk SerShk;

struct SerStaRec {
    char cumErrs;
    char xOffSent;
    char rdPend;
    char wrPend;
    char ctsHold;
    char xOffHold;
};

typedef struct SerStaRec SerStaRec;

#if defined(_AUX_C_EXTENSIONS)

  /* Unknown parameters... */
  OSErr RamSDOpen();
  void RamSDClose();

  OSErr SerReset(short refNum,short serConfig); 
  OSErr SerSetBuf(short refNum,Ptr serBPtr,short serBLen); 
  OSErr SerHShake(short refNum,const SerShk *flags); 
  OSErr SerSetBrk(short refNum); 
  OSErr SerClrBrk(short refNum); 
  OSErr SerGetBuf(short refNum,long *count); 
  OSErr SerStatus(short refNum,SerStaRec *serSta); 

#else /* !_AUX_C_EXTENSIONS */

  OSErr RamSDOpen();
  void RamSDClose();
  OSErr SerReset();
  OSErr SerSetBuf();
  OSErr SerHShake();
  OSErr SerSetBrk();
  OSErr SerClrBrk();
  OSErr SerGetBuf();
  OSErr SerStatus();

#endif /* _AUX_C_EXTENSIONS */

#endif /* __mac_serial_h */
